--[==========================================[
  =         Temporary Ball Container         =
--]==========================================]


require 'ball'

local Balls = {}

Balls.newRandomBall = function (self)
	local radius = RandomGenerator:random(TUNING.BALLS.MIN_RADIUS,TUNING.BALLS.MAX_RADIUS)
	local x = RandomGenerator:random(radius,Client.width-radius)
	local x_vel = RandomGenerator:random(-TUNING.BALLS.MAX_SPAWN_VELOCITY,TUNING.BALLS.MAX_SPAWN_VELOCITY)/10
	local y = RandomGenerator:random(radius,Client.height-radius)
	local y_vel = RandomGenerator:random(-TUNING.BALLS.MAX_SPAWN_VELOCITY,TUNING.BALLS.MAX_SPAWN_VELOCITY)/10
	local color = Color(
		round(RandomGenerator:random(255)),
		round(RandomGenerator:random(255)),
		round(RandomGenerator:random(255))
	)
	local ball = Ball(radius, x, y, x_vel, y_vel, color)
	table.insert(Balls, ball)
end

Balls.draw = function (self, camera)
	for i,Ball in ipairs(Balls) do
		love.graphics.setColor(Ball.color._r, Ball.color._g, Ball.color._b, 200)
		local temp = Ball.position:TransformM(camera.matrix)
		love.graphics.circle( "fill", temp.x, temp.y, Ball.radius*camera.zoom, 36)
	end
end

Balls.clear = function (self)
	for i,Ball in ipairs(Balls) do
		Balls[i] = nil
	end
end

Balls.reset = function (self)
	--- clear any previous balls
	Balls:clear()

	for i=1,TUNING.BALLS.MAX_COUNT do
		Balls:newRandomBall()
	end
end

return Balls
